/**
 *  DreamShell external cmd test
 *  Created by SWAT
 */

#include "ds.h"



int main(int argc, char *argv[]) {
	
    if(argc < 2) {
        ds_printf("Usage: %s option args...\n\n"
                  "Options: \n"
                  " -g, --go     	-Start playing\n\n"
                  "Arguments: \n"
                  " -f, --file     	-File\n\n"
                  "Example: %s -g -f /cd/file.bin\n", argv[0], argv[0]);
        return CMD_NO_ARG; 
    } 


    CFG_CONTEXT con;  
    int go = 0;
    char *file = NULL;

	struct cfg_option options[] = {
		{"go",   'g', NULL, CFG_BOOL, (void *) &go,  0},
		{"file",   'f', NULL, CFG_STR,  (void *) &file,   0},
		CFG_END_OF_LIST
	};
  
  	con = cfg_get_context(options);
    cfg_set_context_flag(con, CFG_IGNORE_UNKNOWN);
  	
	if (con == NULL) {
		ds_printf("DS_ERROR: Not enough memory\n");
		return CMD_ERROR;
	}
	
    cfg_set_cmdline_context(con, 1, -1, argv);

	if (cfg_parse(con) != CFG_OK) {
		ds_printf("DS_ERROR: Error parsing command line: %s\n", cfg_get_error_str(con));
		return CMD_ERROR;
	}
	
	cfg_free_context(con);
	
	if(go) {
		ds_printf("Hello world!\n");
		return CMD_OK;
	}

	return CMD_OK;
}

