/* DreamShell ##version##

   module.c - module example
   Copyright (C)2011 SWAT 

*/
            
#include <kos.h>
#include <kos/exports.h>
#include "ds.h"


extern export_sym_t module_symtab[];
static symtab_handler_t st_module = {
	{ "sym/module_example",
	  0,
	  0x00010000,
	  0,
	  NMMGR_TYPE_SYMTAB,
	  NMMGR_LIST_INIT },
	module_symtab
};



static int builtin_test(int argc, char *argv[]) { 
     
    if(argc < 2) {
        ds_printf("Usage: %s file.dat\n", argv[0]);
        return CMD_NO_ARG; 
    }
    
	if(FileExists(argv[1])) {
		ds_printf("DS_OK: File %s exists\n", argv[1]);
		return CMD_OK; 
	} else {
		ds_printf("DS_ERROR: File %s not exists\n", argv[1]);
		return CMD_ERROR; 
	}
    
    return CMD_OK; 
}



const char * lib_get_name() {
      return "module_example";
}


uint32 lib_get_version() {
       return DS_MAKE_VER(VER_MAJOR, VER_MINOR, VER_MICRO, VER_BUILD);
}


int lib_open(klibrary_t * lib) {
    AddCmd(lib_get_name(), "Module example command", (CmdHandler *) builtin_test); 
	return nmmgr_handler_add(&st_module.nmmgr);
}


int lib_close(klibrary_t * lib) {
	RemoveCmd(GetCmdByName(lib_get_name()));
    return nmmgr_handler_remove(&st_module.nmmgr); 
}


// Export Test
void TestFunctionForExport() {
     ds_printf("Hello from exported function!\n"); 
}
