/** 
 *  \file   	ds.h
 *	\brief  	DreamShell main header
 *	\date		2004-2011
 *	\author		SWAT
 *	\copyright	http://www.dc-swat.ru
 */

#ifndef _DS_MAIN_H
#define _DS_MAIN_H


//#define DS_DEBUG 1

#define true (1 == 1)
#define false (1 == 0)


#ifdef DS_ARCH_PSP

#include <pspkernel.h>
#include <pspctrl.h>
#include <pspdebug.h>
#include <pspdisplay.h>
#include <pspumd.h>
#include <pspkerneltypes.h>
#include <pspthreadman.h>
#include <string.h>
#include <stdarg.h>
#include <dirent.h>
#include <sys/stat.h>
#include "sys/queue.h"
#include "sys/unistd.h"

#define MAX_FN_LEN 512//MAX_NAME //MAXPATHLEN
#define TEMP_DIR "temp"

#ifdef DS_DEBUG
//#define printf Kprintf
//#define printf pspDebugScreenPrintf
#define dbg_printf pspDebugScreenPrintf
#endif


#elif DS_ARCH_DC

#include <kos/cdefs.h>
#include <ctype.h>
#include <malloc.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include <kos/fs.h>
#include <kos/fs_romdisk.h>
#include <kos/fs_ramdisk.h>
#include <kos/fs_pty.h>
#include <kos/limits.h>
#include <kos/thread.h>
#include <kos/sem.h>
#include <kos/rwsem.h>
#include <kos/recursive_lock.h>
#include <kos/once.h>
#include <kos/tls.h>
#include <kos/mutex.h>
#include <kos/cond.h>
#include <kos/genwait.h>
#include <kos/library.h>
//#include <kos/net.h>
#include <kos/nmmgr.h>
#include <kos/exports.h>
#include <kos/dbgio.h>

#include <arch/arch.h>
#include <arch/cache.h>
#include <arch/irq.h>
#include <arch/spinlock.h>
#include <arch/timer.h>
#include <arch/types.h>
#include <arch/exec.h>
#include <arch/stack.h>

#include <arch/mmu.h>
#include <dc/biosfont.h>
#include <dc/cdrom.h>
#include <dc/fs_dcload.h>
#include <dc/fs_iso9660.h>
#include <dc/fs_vmu.h>
#include <dc/asic.h>
#include <dc/maple.h>
#include <dc/maple/controller.h>
#include <dc/maple/keyboard.h>
#include <dc/maple/mouse.h>
#include <dc/maple/vmu.h>
#include <dc/maple/sip.h>
#include <dc/maple/purupuru.h>
#include <dc/vmu_pkg.h>
#include <dc/spu.h>
#include <dc/pvr.h>
#include <dc/video.h>
#include <dc/fmath.h>
#include <dc/matrix.h>
#include <dc/sound/stream.h>
#include <dc/sound/sfxmgr.h>
#include <dc/net/broadband_adapter.h>
#include <dc/net/lan_adapter.h>
#include <dc/modem/modem.h>
#include <dc/sq.h>
#include <dc/ubc.h>
#include <dc/flashrom.h>
#include <dc/vblank.h>
#include <dc/vmufs.h>
#include <dc/scif.h>


#define TEMP_DIR "/ram"

#else

#define MAX_FN_LEN 256
#define TEMP_DIR "temp"

#include <dirent.h>
#include <sys/stat.h>
#include <stdarg.h>
#include <sys/queue.h>
#include <sys/unistd.h>

#endif

#include <stdlib.h>
#include "video.h"
#include "list.h"
#include "thread.h"
#include "module.h"
#include "events.h"
#include "console.h"
#include "lua.h"
#include "app.h"
//#include "fs.h"
#include "utils.h"
#include "cfg+.h"
#include "exceptions.h"
#include "net.h"



#define DS_STATE_RUNNING 0
#define DS_STATE_SLEEP 1
#define DS_STATE_SHUTDOWN 2


int GetState();
void SetState(int state);

char *GetWorkPath();
void SetWorkPath(char *path);

int GetArch();
uint32 GetVersion();
char *GetVersionString();
const char *GetVersionBuildTypeString(int type);

void dbgio_set_dev_ds();
void dbgio_set_dev_scif();
void dbgio_set_dev_fb();
void dbgio_set_dev_sd();


#endif
