/** 
 *  \file   	fs.h
 *	\brief  	Definitions for DreamShell filesystem addons
 *	\date		2004-2011
 *	\author		SWAT
 *	\copyright	http://www.dc-swat.ru
 */


#ifndef _DS_FS_H
#define _DS_FS_H

#ifdef DS_ARCH_DC


/**
 * FAT filesystem
 */

int fs_SDC_init();
int fs_SDC_shutdown();
int fs_SDC_set_SPI_delay(char drv, int speed);

int fs_IDE_init();
int fs_IDE_shutdown();


/**
 * Zip archive filesystem
 */

int fs_zip_init();
void fs_zip_shutdown();

int fs_zip_mount(const char *dir, const char *file);
int fs_zip_unmount(const char *dir);


#endif /* DS_ARCH_DC */

#endif /* _DS_FS_H */
